/** This program waits for notify of file/directory to replace
 *  given directory with symlink
 *  Usage: DirModifyPort.c [testfile] [dir] [link]
 *  gcc -o DirModifyPort DirModifyPort.c
 */

#include <errno.h>
#include <fcntl.h>
#include <port.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

int main(int argc, char **argv) {
  char	*checkFileName;
  struct file_obj *checkFileObj;
  char	*dirName;
  char	*newDirName;
  char	*symlinkTarget;

  int	portHandle;
  struct stat statData;
  port_event_t event;
  int	ret;

  if(argc<4) return(1);
  checkFileName=argv[1];
  dirName=argv[2];
  newDirName=(char*)malloc(strlen(dirName)+256);
  sprintf(newDirName, "%s-moved", dirName);
  symlinkTarget=argv[3];

  portHandle=port_create();

  checkFileObj=malloc(sizeof(struct file_obj));
  checkFileObj->fo_name=strdup(checkFileName);

  stat(checkFileName, &statData);
  checkFileObj->fo_atime=statData.st_atim;
  checkFileObj->fo_mtime=statData.st_mtim;
  checkFileObj->fo_ctime=statData.st_ctim;
  port_associate(portHandle, PORT_SOURCE_FILE, (uintptr_t)checkFileObj,
      FILE_ACCESS|FILE_MODIFIED|FILE_ATTRIB, NULL);

  port_get(portHandle, &event, NULL);
  rename(dirName, newDirName);
  symlink(symlinkTarget, dirName);
  return(0);
}
